## rbdoom3bfg 1.0.3+repack1+git20150625

=== neo/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)

project(RBDoom3BFG)

option(USE_MFC_TOOLS
		"Compile the built-in MFC based tools" OFF)
		
option(MONOLITH
		"Embed game logic into main executable" ON)

option(USE_PRECOMPILED_HEADERS
		"Use precompiled headers during build" ON)
		
option(SDL2
		"Use SDL2 instead of SDL1.2" ON)
		
option(OPENAL
		"Use OpenAL soft instead of XAudio2" OFF)

option(FFMPEG
		"Use FMPEG to render Bink videos" ON)

option(ONATIVE
		"Optimize for the host CPU" OFF)
		
option(WINRT
		"Build for Windows RT" OFF)
		
option(USE_SYSTEM_ZLIB
                "Use the system zlib instead of the bundled one" OFF)

option(USE_SYSTEM_LIBPNG
                "Use the system libpng instead of the bundled one" OFF)

option(USE_SYSTEM_LIBJPEG
                "Use the system libjpeg instead of the bundled one" OFF)

option(USE_SYSTEM_LIBGLEW
                "Use the system libglew instead of the bundled one" OFF)

set(CPU_TYPE "" CACHE STRING "When set, passes this string as CPU-ID which will be embedded into the binary.")

set(CPU_OPTIMIZATION "-mmmx -msse -msse2" CACHE STRING "Which CPU specific optimitations should be used beside the compiler's default?")

option(USE_INTRINSICS "Compile using intrinsics (e.g mmx, sse, msse2)" ON)

if(UNIX)
	set(OPENAL TRUE)
endif()
		
if(MSVC)
	#message(STATUS CMAKE_ROOT: ${CMAKE_ROOT})
	
	#if(CMAKE_CL_64)
	#	SET(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/../bin/win64)
	#else()
	#	SET(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/../bin/win32)
	#endif()
	
	#message(STATUS EXECUTABLE_OUTPUT_PATH: ${EXECUTABLE_OUTPUT_PATH})
	#message(STATUS PROJECT_BINARY_DIR: ${PROJECT_BINARY_DIR})
	#message(STATUS CMAKE_BINARY_DIR: ${CMAKE_BINARY_DIR})
else()
	message(STATUS CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE})
endif()

if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID STREQUAL "Clang")
	add_definitions(-pipe)
	#add_definitions(-Wall)
	add_definitions(-Werror=format-security)
	add_definitions(-Werror=format)
	if(CPU_TYPE)
		add_definitions(-DCPUSTRING="${CPU_TYPE}")
	endif()
	if (CPU_OPTIMIZATION)
		add_definitions(${CPU_OPTIMIZATION})
	endif()
	if (USE_INTRINSICS)
		add_definitions(-DUSE_INTRINSICS)
	endif()
	if(WIN32)
		# require msvcr70.dll or newer for _aligned_malloc etc
		# I think it is from Visual C++ .NET 2002, so it should be available on any remotely modern system.
		add_definitions(-D__MSVCRT_VERSION__=0x0700)
		
		find_package(DirectX REQUIRED)
		include_directories(libs/mingw-hacks)
		include_directories(${DirectX_INCLUDE_DIR})
		add_definitions(-DUSE_XINPUT)
	endif()	
	
	#if(NOT ANDROID)
		add_definitions(-DUSE_EXCEPTIONS)
	#endif()
	
	# the warnings are used for every profile anyway, so put them in a variable
	set(my_warn_flags "-Wno-pragmas -Wno-unused-variable -Wno-switch -Wno-unused-value -Winvalid-pch -Wno-multichar")
	
	if(CMAKE_C_COMPILER_ID STREQUAL "Clang")
		# append clang-specific settings for warnings (the second one make sure clang doesn't complain
		# about unknown -W flags, like -Wno-unused-but-set-variable)
		set(my_warn_flags "${my_warn_flags} -Wno-local-type-template-args -Wno-unknown-warning-option -Wno-inline-new-delete -Wno-switch-enum")
	endif()
	
	if(NOT CMAKE_CROSSCOMPILING AND ONATIVE)
		add_definitions(-march=native)
	endif()

	set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -D_DEBUG -O0 -ggdb -fno-strict-aliasing ${my_warn_flags}")
	#set(CMAKE_C_FLAGS_DEBUGALL "${CMAKE_C_FLAGS_DEBUGALL} -g -ggdb -D_DEBUG -fno-strict-aliasing ${my_warn_flags}")
	#set(CMAKE_C_FLAGS_PROFILE "${CMAKE_C_FLAGS_PROFILE} -g -ggdb -D_DEBUG -O1 -fno-omit-frame-pointer -fno-strict-aliasing ${my_warn_flags}")
	set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -O3 -ffast-math -fno-unsafe-math-optimizations -fomit-frame-pointer -fno-strict-aliasing ${my_warn_flags}")
	set(CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_RELWITHDEBINFO} -g -O3 -ffast-math -fno-unsafe-math-optimizations -fomit-frame-pointer -fno-strict-aliasing ${my_warn_flags}")
	set(CMAKE_C_FLAGS_MINSIZEREL "${CMAKE_C_FLAGS_MINSIZEREL} -Os -ffast-math -fno-unsafe-math-optimizations -fomit-frame-pointer -fno-strict-aliasing ${my_warn_flags}")
	
	set(CMAKE_CXX_FLAGS_DEBUG ${CMAKE_C_FLAGS_DEBUG})
	#set(CMAKE_CXX_FLAGS_DEBUGALL ${CMAKE_C_FLAGS_DEBUGALL})
	#set(CMAKE_CXX_FLAGS_PROFILE ${CMAKE_C_FLAGS_PROFILE})
	set(CMAKE_CXX_FLAGS_RELEASE ${CMAKE_C_FLAGS_RELEASE})
	set(CMAKE_CXX_FLAGS_RELWITHDEBINFO ${CMAKE_C_FLAGS_RELWITHDEBINFO})
	set(CMAKE_CXX_FLAGS_MINSIZEREL ${CMAKE_C_FLAGS_MINSIZEREL})

elseif(MSVC)
	
	# Multiprocessor support for compiling
	# /MP
	
	# /MT  use multithreaded, static runtime library
	#      (=> binary won't need MSVCP100D.dll or similar)
	# /MTd the same with debug symbols
	# /MD and /MDd - the same with dynamic runtime lib
	#     (=> MSVCP100D.dll or similar is needed to run binary)

	# Inline Function Expansion: Any Suitable (/Ob2)
	# "/Ob2",
			
	# enable Intrinsic Functions
	# "/Oi",
			
	# Omit Frame Pointers
	# "/Oy",
	
	# if(MSVC_VERSION EQUAL 1700)
		# #message(STATUS "$ENV{LIBPATH}")
		
		# find_path(Windows_winmd_DIR NAMES Windows.winmd
			# HINTS
			# C:/Program Files (x86)/Windows Kits/8.0/References/CommonConfiguration/Neutral
			# PATH_SUFFIXES "Neutral")
			
		# message(STATUS "${Windows_winmd_DIR}")
		
		# #set(WINRT_OPTIONS "/ZW /D USE_WINRT /AI \"C:\Program Files (x86)\Windows Kits\8.0\References\CommonConfiguration\Neutral\"")
		# #set(WINRT_OPTIONS "/ZW /D USE_WINRT /AI \"$ENV{LIBPATH}\" ")
		# set(WINRT_OPTIONS "/ZW /D USE_WINRT")
	
		# set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} /D _DEBUG /MP ${WINRT_OPTIONS}")
		# set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} /MP /Oi /Oy ${WINRT_OPTIONS}")
		# set(CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_RELWITHDEBINFO} /MP /Oi ${WINRT_OPTIONS}")
		# set(CMAKE_C_FLAGS_MINSIZEREL "${CMAKE_C_FLAGS_MINSIZEREL} /MP /Oi /Oy ${WINRT_OPTIONS}")
		
		# set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MP ${WINRT_OPTIONS}")
		# set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MP /Oi /Oy ${WINRT_OPTIONS}")
		# set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} /MP ${WINRT_OPTIONS}")
		# set(CMAKE_CXX_FLAGS_MINSIZEREL "${CMAKE_CXX_FLAGS_MINSIZEREL} /MP /Oi /Oy ${WINRT_OPTIONS}")
	# else()
		set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} /D _DEBUG /MP /MTd")
		set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} /MP /Oi /Oy /MT")
		set(CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_RELWITHDEBINFO} /MP /Oi /MTd")
		set(CMAKE_C_FLAGS_MINSIZEREL "${CMAKE_C_FLAGS_MINSIZEREL} /MP /Oi /Oy /MT")
		
		set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MP /MTd")
		set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MP /Oi /Oy /MT")
		set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} /MP /MTd")
		set(CMAKE_CXX_FLAGS_MINSIZEREL "${CMAKE_CXX_FLAGS_MINSIZEREL} /MP /Oi /Oy /MT")
		
		# RB: without /SAFESEH:NO we can't link against ffmpeg libs and VS2013 or we have to build our own
		# libs for newer compilers
		set(CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} /SAFESEH:NO")
		set(CMAKE_EXE_LINKER_FLAGS_MINSIZEREL "${CMAKE_EXE_LINKER_FLAGS_MINSIZEREL} /SAFESEH:NO")
		set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /SAFESEH:NO")
		set(CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO} /SAFESEH:NO")
	# endif()
	

	add_definitions(-DWIN32 
					-D_WINDOWS
					-D_CRT_SECURE_NO_DEPRECATE
					-D_CRT_NONSTDC_NO_DEPRECATE
					-D_CRT_SECURE_NO_WARNINGS
                                        -D_MBCS
                                       #-DUSE_OPENAL
					-DUSE_EXCEPTIONS)
        ## Check for Version ##
        if( WINRT ) # Windows RT
                add_definitions(-DUSE_WINRT)
        endif()
					
	if(NOT CMAKE_CL_64)
		add_definitions(-D_USE_32BIT_TIME_T)
	endif()
					
	if(USE_MFC_TOOLS)
		add_definitions(-D_AFXDLL)
		
		# 0: Use Standard Windows Libraries
		# 1: Use MFC in a Static Library
		# 2: Use MFC in a Shared DLL 
		set(CMAKE_MFC_FLAG 2)
	endif()
endif()

#if(STANDALONE)
#	add_definitions(-DSTANDALONE)
#endif()

if (USE_SYSTEM_ZLIB)
  find_package(ZLIB REQUIRED)
endif(USE_SYSTEM_ZLIB)

if (ZLIB_FOUND)
    include_directories(${ZLIB_INCLUDE_DIRS})
    set(ZLIB_LIBRARY ${ZLIB_LIBRARIES})
else (ZLIB_FOUND)
    include_directories("libs/zlib")
    set(ZLIB_LIBRARY "" )
endif (ZLIB_FOUND)

if(USE_SYSTEM_LIBPNG)
find_package(PNG REQUIRED)
endif (USE_SYSTEM_LIBPNG)

if (PNG_FOUND)
    include_directories(${PNG_INCLUDE_DIRS})
    set(PNG_LIBRARY ${PNG_LIBRARIES})
else (PNG_FOUND)
    include_directories("libs/png")
    set(PNG_LIBRARY "" )
endif (PNG_FOUND)


if(USE_SYSTEM_LIBJPEG)
find_package(JPEG REQUIRED)
endif(USE_SYSTEM_LIBJPEG)

if (JPEG_FOUND)
    include_directories(${JPEG_INCLUDE_DIRS})
    set(JPEG_LIBRARY ${JPEG_LIBRARIES})
    add_definitions(-DUSE_NEWER_JPEG)
else (JPEG_FOUND)
    include_directories("libs/jpeg-6")
    set(JPEG_LIBRARY "" )
endif (JPEG_FOUND)

if (USE_SYSTEM_LIBGLEW)
find_package(GLEW)
endif(USE_SYSTEM_LIBGLEW)

if (GLEW_FOUND)
    include_directories(${GLEW_INCLUDE_DIRS})
    set(GLEW_LIBRARY ${GLEW_LIBRARIES})
else (GLEW_FOUND)
    include_directories("libs/glew/include")
    set(GLEW_LIBRARY "" )
    add_definitions(-DGLEW_STATIC)
endif (GLEW_FOUND)

add_subdirectory(idlib)

file(GLOB AAS_INCLUDES aas/*.h)
file(GLOB AAS_SOURCES aas/*.cpp)

file(GLOB_RECURSE CM_INCLUDES cm/*.h)
file(GLOB_RECURSE CM_SOURCES cm/*.cpp)

file(GLOB FRAMEWORK_INCLUDES framework/*.h)
file(GLOB FRAMEWORK_SOURCES framework/*.cpp)

file(GLOB FRAMEWORK_ASYNC_INCLUDES framework/async/*.h)
file(GLOB FRAMEWORK_ASYNC_SOURCES framework/async/*.cpp)

file(GLOB RENDERER_INCLUDES renderer/*.h)
	# renderer/AutoRender.h
	# renderer/AutoRenderBink.h
	# renderer/BinaryImage.h
	# renderer/BinaryImageData.h
	# renderer/BoundsTrack.h
	# renderer/BufferObject.h
	# renderer/Cinematic.h
	# renderer/Font.h
	# renderer/GLMatrix.h
	# renderer/GLState.h
	# renderer/GuiModel.h
	# renderer/Image.h
	# renderer/ImageOpts.h
	# renderer/Interaction.h
	# renderer/Material.h
	# renderer/Model.h
	# renderer/ModelDecal.h
	# renderer/ModelManager.h
	# renderer/ModelOverlay.h
	# renderer/Model_ase.h
	# #renderer/Model_ColladaHelper.h
	# #renderer/Model_ColladaParser.h
	# renderer/Model_local.h
	# renderer/Model_lwo.h
	# renderer/Model_ma.h
	# renderer/Model_md3.h
	# renderer/RenderLog.h
	# renderer/RenderProgs.h
	# renderer/RenderSystem.h
	# renderer/RenderTexture.h
	# renderer/RenderWorld.h
	# renderer/RenderWorld_local.h
	# renderer/ResolutionScale.h
	# renderer/ScreenRect.h
	# renderer/simplex.h
	# renderer/tr_local.h
	# renderer/VertexCache.h)


file(GLOB RENDERER_SOURCES renderer/*.cpp)
	# renderer/AutoRender.cpp
	# renderer/Cinematic.cpp
	# renderer/Framebuffer.cpp
	# renderer/GLShader.cpp
	# renderer/GuiModel.cpp
	# renderer/Image_files.cpp
	# renderer/Image_init.cpp
	# renderer/Image_load.cpp
	# renderer/Image_process.cpp
	# renderer/Image_program.cpp
	# renderer/Interaction.cpp
	# renderer/Material.cpp
	# renderer/Model.cpp
	# renderer/ModelDecal.cpp
	# renderer/ModelManager.cpp
	# renderer/ModelOverlay.cpp
	# renderer/Model_ase.cpp
	# renderer/Model_beam.cpp
	# #renderer/Model_ColladaParser.cpp
	# renderer/Model_liquid.cpp
	# renderer/Model_lwo.cpp
	# renderer/Model_ma.cpp
	# renderer/Model_md3.cpp
	# renderer/Model_md5.cpp
	# renderer/Model_prt.cpp
	# renderer/Model_sprite.cpp
	# renderer/RenderEntity.cpp
	# renderer/RenderSystem.cpp
	# renderer/RenderSystem_init.cpp
	# renderer/RenderWorld.cpp
	# renderer/RenderWorld_demo.cpp
	# renderer/RenderWorld_load.cpp
	# renderer/RenderWorld_portals.cpp
	# renderer/VertexCache.cpp
	# renderer/draw_arb.cpp
	# renderer/draw_arb2.cpp
	# renderer/draw_glsl.cpp
	# renderer/draw_common.cpp
	# renderer/draw_exp.cpp
	# renderer/draw_nv10.cpp
	# renderer/draw_nv20.cpp
	# renderer/draw_r200.cpp
	# renderer/tr_backend.cpp
	# renderer/tr_deform.cpp
	# renderer/tr_font.cpp
	# renderer/tr_guisurf.cpp
	# renderer/tr_light.cpp

=== debian/changelog ===
rbdoom3bfg (1.0.3+repack1+git20150625-1build1) wily; urgency=medium

  * No-change rebuild against ffmpeg 2.7

 -- Rico Tzschichholz <ricotz@ubuntu.com>  Tue, 01 Sep 2015 18:25:26 +0200

rbdoom3bfg (1.0.3+repack1+git20150625-1) unstable; urgency=medium

  * New uptream git snapshot.
  * Refreshing/Removing patches:
   - 10-lowercase-executeable.patch refreshed
   - 75-local-no-precompiled-header.patch removed, applied upstream
   - 80-disable-cpu-features.patch refreshed, almost applied upstream completly
   - 82-enable-hurd-kfreebsd.patch removed, applied upstream
  * Work towards reprdoucible builds
  * Fix get-orig-target to produce the right version string

 -- Tobias Frost <tobi@debian.org>  Sat, 11 Jul 2015 09:32:44 +0200

rbdoom3bfg (1.0.3+repack1-5) unstable; urgency=medium

  * Generalized & Forwarded patch 80-disable-cpu-features.patch
  * Modified d/rules to utilize this patch and enable mmx, sse and co on amd64
  * Refactor patch to disable precompiled headers  be upstreamable
  * Add --as-needed to linker flags
  * New patch: Try to compile on hurd and kfreebsd as well

 -- Tobias Frost <tobi@debian.org>  Sun, 21 Jun 2015 17:23:43 +0200

rbdoom3bfg (1.0.3+repack1-4) unstable; urgency=medium

  * Again, patch incomplete. Now also submitting the cpu information.

 -- Tobias Frost <tobi@debian.org>  Sat, 13 Jun 2015 15:48:59 +0200

rbdoom3bfg (1.0.3+repack1-3) unstable; urgency=medium

  * The patch to disable the CPU features was incomplete: We need also to undef
    the usage of intriniscs for all CPU'S except on amd64

 -- Tobias Frost <tobi@debian.org>  Sat, 13 Jun 2015 14:18:36 +0200

rbdoom3bfg (1.0.3+repack1-2) unstable; urgency=medium

  * Add patch to disable using CPU features like sse and mmx.
  * Rename local patch to free up the namespace a little bit.
  * Add the Debian Games Team to Uploaders in d/control

 -- Tobias Frost <tobi@debian.org>  Fri, 12 Jun 2015 18:17:07 +0200

rbdoom3bfg (1.0.3+repack1-1) unstable; urgency=medium

  * Initial release (Closes: #764200)

 -- Tobias Frost <tobi@debian.org>  Wed, 11 Mar 2015 12:52:36 +0100

=== debian/rules ===
#!/usr/bin/make -f

# output every command that modifies files on the build system.
#DH_VERBOSE = 1

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

CMAKE_ADDTIONAL_FLAGS ?=
ifeq ($(findstring $(DEB_BUILD_ARCH), amd64 kfreebsd-amd64),)
CMAKE_ADDITIONAL_FLAGS ?= -DUSE_INTRINSICS=OFF
endif

%:
	dh $@ --sourcedirectory=neo --parallel

# debmake generated override targets
# This is example for Cmake (See http://bugs.debian.org/641051 )
override_dh_auto_configure:
	dh_auto_configure -- -G "Unix Makefiles" \
	 -DSDL2=ON -DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
	 -DUSE_SYSTEM_ZLIB=ON -DUSE_SYSTEM_LIBPNG=ON \
	 -DUSE_SYSTEM_LIBJPEG=ON -DUSE_SYSTEM_LIBGLEW=ON \
	 -DCPU_TYPE=$(DEB_BUILD_ARCH_CPU) \
	 -DUSE_PRECOMPILED_HEADERS=OFF \
	 -DCPU_OPTIMIZATION="" \
	 $(CMAKE_ADDITIONAL_FLAGS)

override_dh_installchangelogs:
	# We won't have a ChangeLog if packaging from a released tarball.
	# In this case, use the RELEASE-NOTES.txt
	dh_installchangelogs
	if [ ! -e ChangeLog ]; then \
	dh_installchangelogs -k RELEASE-NOTES.txt ; \
	fi

# For get-orig-source
UURL =  https://github.com/RobertBeckebans/RBDOOM-3-BFG.git
PKD   = $(abspath $(dir $(MAKEFILE_LIST)))
PKG   = $(word 2,$(shell dpkg-parsechangelog -l$(PKD)/changelog | grep ^Source))
VER  ?= $(shell dpkg-parsechangelog -l$(PKD)/changelog  -SVersion | sed -e s/^.*git// | cut -d- -f1 )
DTYPE = +repack1
UPSVER ?= $(shell dpkg-parsechangelog -l$(PKD)/changelog -SVersion | cut -d+ -f1)

## from: https://wiki.debian.org/onlyjob/get-orig-source
.PHONY: get-orig-source
get-orig-source: $(PKG)_$(UPSVER)+git$(VER)$(DTYPE).orig.tar.xz
	#$(info I: $(UPSVER$)~$(PKG)_$(VER)$(DTYPE))
	@

UDATE = $(shell date --rfc-3339=seconds --date='TZ="UTC" \
	$(shell echo +git$(VER) | perl -ne 'print "$$1-$$2-$$3" if m/\~(?:git|svn|hg)(\d{4})(\d{2})(\d{2})/')')

$(PKG)_$(UPSVER)+git$(VER)$(DTYPE).orig.tar.xz:
	@echo DEBUG: VER=$(VER) UDATE=$(UDATE) UPSVER=$(UPSVER)
	@echo "$(PKG)_$(UPSVER)+git$(VER)$(DTYPE).orig.tar.xz"
	@echo $(VER) | grep '^[0-9]*$$' || ( echo Cannot find timestamp in package version. Please specify VER, see README.source. Aborting.. ; exit 1 )
	#$(info I: UDATE=$(UDATE))
	$(if $(wildcard $(PKG)-$(UPSVER)+git$(VER)),$(error $(PKG)-$(UPSVER)+git$(VER) exist, aborting..))
	@echo "# Downloading..."
	git clone $(UURL) $(PKG)-$(UPSVER)+git$(VER) \
	|| $(RM) -r $(PKG)-$(UPSVER)+git$(VER)
	cd $(PKG)-$(UPSVER)+git$(VER) \
	&& git checkout v$(VER) || git checkout $$(git log -n1 --format=%h --before="$(UDATE)") \
	&& ( echo "# Generating ChangeLog..." \
	&& git log --pretty="format:%ad  %aN  <%aE>%n%n%x09* %s%n" --date=short > ChangeLog \
	&& touch -d "$$(git log -1 --format='%ci')" ChangeLog) \
	&& echo "# Setting times..." \
	&& for F in $$(git ls-tree -r --name-only HEAD); do touch --no-dereference -d "$$(git log -1 --format="%ai" -- $$F)" "$$F"; done \
	&& echo "# Cleaning-up..." \
	&& $(RM) -r -v $$(awk 'BEGIN{RS=ORS="\n\n";FS=OFS="\n"}/Files-Excluded:/' $(PKD)/copyright | sed s/Files-Excluded://) \
	&& $(RM) -r .git .git*
	@echo "# Packing..."
	find -L "$(PKG)-$(UPSVER)+git$(VER)" -xdev -type f -print | sort \
	| XZ_OPT="-6v" tar -caf "$(PKG)_$(UPSVER)$(DTYPE)+git$(VER).orig.tar.xz" -T- --owner=root --group=root --mode=a+rX \
	&& $(RM) -r "$(PKG)-$(UPSVER)+git$(VER)"

## rbdoom3bfg 1.0.3+repack1+git20151124

=== neo/CMakeLists.txt ===
--- 
+++ 
@@ -195,6 +195,10 @@
         ## Check for Version ##
         if( WINRT ) # Windows RT
                 add_definitions(-DUSE_WINRT)
+        endif()
+
+        if (USE_INTRINSICS)
+                add_definitions(-DUSE_INTRINSICS)
         endif()
 					
 	if(NOT CMAKE_CL_64)
@@ -364,7 +368,3 @@
 	# renderer/draw_nv20.cpp
 	# renderer/draw_r200.cpp
 	# renderer/tr_backend.cpp
-	# renderer/tr_deform.cpp
-	# renderer/tr_font.cpp
-	# renderer/tr_guisurf.cpp
-	# renderer/tr_light.cpp

=== neo/idlib/CMakeLists.txt ===

add_definitions(-D__IDLIB__ -D__DOOM_DLL__)

file(GLOB ID__INCLUDES *.h)
file(GLOB ID__SOURCES *.cpp)
file(GLOB ID_BV_INCLUDES bv/*.h)
file(GLOB ID_BV_SOURCES bv/*.cpp)
file(GLOB ID_CONTAINERS_INCLUDES containers/*.h)
file(GLOB ID_CONTAINERS_SOURCES containers/*.cpp)
file(GLOB ID_GEOMETRY_INCLUDES geometry/*.h)
file(GLOB ID_GEOMETRY_SOURCES geometry/*.cpp)
file(GLOB ID_HASHING_INCLUDES hashing/*.h)
file(GLOB ID_HASHING_SOURCES hashing/*.cpp)
file(GLOB ID_MATH_INCLUDES math/*.h)
file(GLOB ID_MATH_SOURCES math/*.cpp)
file(GLOB ID_SYS_INCLUDES sys/*.h)
file(GLOB ID_SYS_SOURCES sys/*.cpp)

if(MSVC)
	file(GLOB ID_SYS_WIN32_INCLUDES sys/win32/*.h)
	file(GLOB ID_SYS_WIN32_SOURCES sys/win32/*.cpp)
else()
	file(GLOB ID_SYS_POSIX_INCLUDES sys/posix/*.h)
	file(GLOB ID_SYS_POSIX_SOURCES sys/posix/*.cpp)
endif()

set(ID_INCLUDES_ALL
			${ID__INCLUDES}
			${ID_BV_INCLUDES}
			${ID_CONTAINERS_INCLUDES}
			${ID_GEOMETRY_INCLUDES}
			${ID_HASHING_INCLUDES}
			${ID_MATH_INCLUDES}
			${ID_SYS_INCLUDES}
			)
			
set(ID_SOURCES_ALL
			${ID__SOURCES}
			${ID_BV_SOURCES}
			${ID_CONTAINERS_SOURCES}
			${ID_GEOMETRY_SOURCES}
			${ID_HASHING_SOURCES}
			${ID_MATH_SOURCES}
			${ID_SYS_SOURCES}
			)
			
if(MSVC)
	list(APPEND ID_INCLUDES_ALL ${ID_SYS_WIN32_INCLUDES})
	list(APPEND ID_SOURCES_ALL ${ID_SYS_WIN32_SOURCES})
else()
	list(APPEND ID_INCLUDES_ALL ${ID_SYS_POSIX_INCLUDES})
	list(APPEND ID_SOURCES_ALL ${ID_SYS_POSIX_SOURCES})
endif()

source_group("" FILES ${ID__INCLUDES})
source_group("" FILES ${ID__SOURCES})
source_group("bv" FILES ${ID_BV_INCLUDES})
source_group("bv" FILES ${ID_BV_SOURCES})
source_group("containers" FILES ${ID_CONTAINERS_INCLUDES})
source_group("containers" FILES ${ID_CONTAINERS_SOURCES})
source_group("geometry" FILES ${ID_GEOMETRY_INCLUDES})
source_group("geometry" FILES ${ID_GEOMETRY_SOURCES})
source_group("hashing" FILES ${ID_HASHING_INCLUDES})
source_group("hashing" FILES ${ID_HASHING_SOURCES})
source_group("math" FILES ${ID_MATH_INCLUDES})
source_group("math" FILES ${ID_MATH_SOURCES})
source_group("sys" FILES ${ID_SYS_INCLUDES})
source_group("sys" FILES ${ID_SYS_SOURCES})

if(MSVC)
	source_group("sys\\win32" FILES ${ID_SYS_WIN32_INCLUDES})
	source_group("sys\\win32" FILES ${ID_SYS_WIN32_SOURCES})
else()
	source_group("sys\\posix" FILES ${ID_SYS_POSIX_INCLUDES})
	source_group("sys\\posix" FILES ${ID_SYS_POSIX_SOURCES})
endif()

#if(STANDALONE)
#	add_definitions(-DSTANDALONE)
#endif()

set(ID_PRECOMPILED_SOURCES ${ID_SOURCES_ALL})
list(REMOVE_ITEM ID_PRECOMPILED_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/geometry/RenderMatrix.cpp)
list(REMOVE_ITEM ID_PRECOMPILED_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/SoftwareCache.cpp)

if(MSVC)
    list(REMOVE_ITEM ID_PRECOMPILED_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/precompiled.cpp)

    #set_target_properties(idlib PROPERTIES COMPILE_FLAGS "/Yuprecompiled.h")
    set_source_files_properties(precompiled.cpp
        PROPERTIES
        COMPILE_FLAGS "/Ycprecompiled.h"
        OBJECT_OUTPUTS "precompiled.pch"
        )
        set_source_files_properties(
            ${ID_PRECOMPILED_SOURCES}
            PROPERTIES
            COMPILE_FLAGS "/Yuprecompiled.h"
            OBJECT_DEPENDS "precompiled.pch"
            )

    add_library(idlib ${ID_SOURCES_ALL} ${ID_INCLUDES_ALL})
else()
	if (USE_PRECOMPILED_HEADERS)
	foreach( src_file ${ID_PRECOMPILED_SOURCES} )
		#message(STATUS "-include precompiled.h for ${src_file}")
		set_source_files_properties(
			${src_file}
			PROPERTIES
			COMPILE_FLAGS "-include ${CMAKE_CURRENT_SOURCE_DIR}/precompiled.h"
			)
	endforeach()
	endif()

	include_directories(.)
	
	if (USE_PRECOMPILED_HEADERS)
	# precompiled magic for GCC/clang, adapted from https://gist.github.com/573926
	STRING(TOUPPER "CMAKE_CXX_FLAGS_${CMAKE_BUILD_TYPE}" _flags_var_name)
	SET(_compiler_FLAGS ${${_flags_var_name}})
	GET_DIRECTORY_PROPERTY(_directory_flags INCLUDE_DIRECTORIES)
	FOREACH(item ${_directory_flags})
		LIST(APPEND _compiler_FLAGS " -I${item}")
	ENDFOREACH(item)
	endif()

	GET_DIRECTORY_PROPERTY(_directory_flags DEFINITIONS)
	LIST(APPEND _compiler_FLAGS ${_directory_flags})
	
	SEPARATE_ARGUMENTS(_compiler_FLAGS)
	
	if (USE_PRECOMPILED_HEADERS)
	add_custom_target(precomp_header_idlib ALL
	                  COMMAND ${CMAKE_CXX_COMPILER} ${_compiler_FLAGS} -x c++-header precompiled.h -o precompiled.h.gch
	                  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
	                  COMMENT "Creating idlib/precompiled.h.gch for idlib"
	                  )
	endif()
	
	add_library(idlib ${ID_SOURCES_ALL} ${ID_INCLUDES_ALL})
	if (USE_PRECOMPILED_HEADERS)
	add_dependencies(idlib precomp_header_idlib)
	endif()
	
endif()
	

# if(MSVC)
	# # set_source_files_properties(precompiled.cpp
        # # PROPERTIES
        # # COMPILE_FLAGS "/Ycprecompiled.h"
        # # )
		
	# #set_target_properties(idlib PROPERTIES COMPILE_FLAGS "/Yuprecompiled.h")
# endif()

=== debian/changelog ===
rbdoom3bfg (1.0.3+repack1+git20151124-1) unstable; urgency=medium

  * New upstream git snapshot.
  * Fix FTBFS with libpng1.6 (Closes: #809866)

 -- Tobias Frost <tobi@debian.org>  Mon, 25 Jan 2016 21:53:13 +0100

rbdoom3bfg (1.0.3+repack1+git20151103-1) unstable; urgency=medium

  * New upstream git snapshot.
  * Fix "FTBFS with FFmpeg 2.9", using the patch from Andreas Cadhalpun
    (Closes: #803857)
  * Forwarded reproducible patch, noting that in the dep3 header

 -- Tobias Frost <tobi@debian.org>  Tue, 03 Nov 2015 21:39:01 +0100

rbdoom3bfg (1.0.3+repack1+git20150806-1) unstable; urgency=medium

  * New upstream git snapshot.
    - Remove patch 80-disable-cpu-features.patch -- applied upstream
    - Patches refreshed as required.
  * Fix git-get-orig rule: Did not pull the requested date, but always
    the newest version

 -- Tobias Frost <tobi@debian.org>  Sun, 13 Sep 2015 22:21:09 +0200

=== debian/control ===
Source: rbdoom3bfg
Section: games
Priority: optional
Maintainer: Tobias Frost <tobi@debian.org>
Uploaders: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Build-Depends: cmake,
               debhelper (>= 9),
               libavcodec-dev | libavcodec-ffmpeg-dev,
               libavformat-dev | libavformat-ffmpeg-dev,
               libavutil-dev | libavutil-ffmpeg-dev,
               libglew-dev,
               libjpeg-dev,
               libopenal-dev,
               libpng12-dev,
               libsdl2-dev,
               libswscale-dev | libswscale-ffmpeg-dev,
               zlib1g-dev
Standards-Version: 3.9.6
Homepage: https://github.com/RobertBeckebans/RBDOOM-3-BFG
VCS-Browser: http://anonscm.debian.org/cgit/pkg-games/rbdoom3bfg.git
VCS-Git: git://anonscm.debian.org/pkg-games/rbdoom3bfg.git

Package: rbdoom3bfg
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: doom3bfg-data | game-data-packager (>= 40)
Description: Doom3 BFG edition game engine
 RBDoom3BFG 3 is a Doom 3 BFG GPL source modification. The goal of RBDoom3BFG 3
 is to bring Doom 3 BFG with the help of SDL to all suitable platforms. Bugs
 present in the original DOOM 3 will be fixed (when identified) without altering
 the original game-play.
 .
 Note, to play the original game, you'll need a copy of the game data.
 .
 The package can also be used with free map data, like the demomap from
 OpenTechBFG.

=== debian/rules ===
--- 
+++ 
@@ -46,16 +46,16 @@
 ## from: https://wiki.debian.org/onlyjob/get-orig-source
 .PHONY: get-orig-source
 get-orig-source: $(PKG)_$(UPSVER)+git$(VER)$(DTYPE).orig.tar.xz
-	#$(info I: $(UPSVER$)~$(PKG)_$(VER)$(DTYPE))
+	#$(info I: $(UPSVER$)+$(PKG)_$(VER)$(DTYPE))
 	@
 
 UDATE = $(shell date --rfc-3339=seconds --date='TZ="UTC" \
-	$(shell echo +git$(VER) | perl -ne 'print "$$1-$$2-$$3" if m/\~(?:git|svn|hg)(\d{4})(\d{2})(\d{2})/')')
+	$(shell echo +git$(VER) | perl -ne 'print "$$1-$$2-$$3" if m/\+(?:git|svn|hg)(\d{4})(\d{2})(\d{2})/')')
 
 $(PKG)_$(UPSVER)+git$(VER)$(DTYPE).orig.tar.xz:
 	@echo DEBUG: VER=$(VER) UDATE=$(UDATE) UPSVER=$(UPSVER)
 	@echo "$(PKG)_$(UPSVER)+git$(VER)$(DTYPE).orig.tar.xz"
-	@echo $(VER) | grep '^[0-9]*$$' || ( echo Cannot find timestamp in package version. Please specify VER, see README.source. Aborting.. ; exit 1 )
+	@echo $(VER) | grep -q '^[0-9]*$$' || ( echo Cannot find timestamp in package version. Please specify VER, see README.source. Aborting.. ; exit 1 )
 	#$(info I: UDATE=$(UDATE))
 	$(if $(wildcard $(PKG)-$(UPSVER)+git$(VER)),$(error $(PKG)-$(UPSVER)+git$(VER) exist, aborting..))
 	@echo "# Downloading..."
@@ -69,7 +69,7 @@
 	&& echo "# Setting times..." \
 	&& for F in $$(git ls-tree -r --name-only HEAD); do touch --no-dereference -d "$$(git log -1 --format="%ai" -- $$F)" "$$F"; done \
 	&& echo "# Cleaning-up..." \
-	&& $(RM) -r -v $$(awk 'BEGIN{RS=ORS="\n\n";FS=OFS="\n"}/Files-Excluded:/' $(PKD)/copyright | sed s/Files-Excluded://) \
+	&& $(RM) -r -v $$(awk 'BEGIN{RS=ORS="\n\n";FS=OFS="\n"}/Files-Excluded:/' $(PKD)/copyright | sed -n -e '/^Files-Excluded:/,$${p}' | sed s/Files-Excluded://) \
 	&& $(RM) -r .git .git*
 	@echo "# Packing..."
 	find -L "$(PKG)-$(UPSVER)+git$(VER)" -xdev -type f -print | sort \

=== debian/watch ===
version=3
# note, this watchfile should not be used to download new upstream versions --
# please use get-orig-source; refer to README.source.
# this files only purpose is to track new upstream tagged releases.
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/rbdoom3bfg-$1\.tar\.gz/,\
dversionmangle=s/\+git.*$//;s/\+repack.*$//,uversionmangle=s/-/~/,\
repacksuffix=+repack \
  https://github.com/RobertBeckebans/RBDOOM-3-BFG/tags .*/v?(\d\S*)\.tar\.gz

## rbdoom3bfg 1.1.0~preview3+dfsg+git20160807

=== debian/changelog ===
rbdoom3bfg (1.1.0~preview3+dfsg+git20160807-2) unstable; urgency=medium

  * Disable HDR rendering by default as this can create some graphical
    glitches, especially when used together with SSAO. Done by patch
    70-disable-hdr-by-default.patch

 -- Tobias Frost <tobi@debian.org>  Sat, 15 Oct 2016 17:48:41 +0200

rbdoom3bfg (1.1.0~preview3+dfsg+git20160807-1) unstable; urgency=medium

  * New upstream git snapshot.
    - Refreshed patches to remove fuzz.
    - 70-ffmpeg_2.9.patch is obsolete, upstream fixed issue, so rm from series.
    - 20-reproducible.patch updated to remove one additional __DATE__.
    - Add new files to d/copyright,
      - neo/renderer/SMAA/*: licensed expat
      - neo/libs/irrxml/*: licensed libpng/zlib
    - Switch to dfsg suffix as files removed without source. (docs of rirrxml)
    - those files and rapidjson is removed via d/copyright's Files-Excluded.
  * New patch 90-system-rapidjson.patch to utilize Debian's rapidjson
  * Fix typo in d/README.source -- the var is UPSVER not USVER.
  * Bump S-V -- no changes
  * Change compat level to 10, "--parallel" in d/rules is now default and so
    was dropped.
  * Deleted (long ago) applied upstream patch 70-ffmpeg_2.9.patch
  * Renumbering patches to free up numberspace
  * New patch 60-fix-spelling-errors correcting the errors reported by lintian.
  * d/control Replace non VCS-* with https:// ones

 -- Tobias Frost <tobi@debian.org>  Sat, 15 Oct 2016 11:53:19 +0200

rbdoom3bfg (1.0.3+repack1+git20151124-2) unstable; urgency=medium

  * Mark libpng1.6 patch as forwarded.
  * Change B-D to libpng-dev.

 -- Tobias Frost <tobi@debian.org>  Mon, 28 Mar 2016 16:46:38 +0200

=== debian/control ===
--- 
+++ 
@@ -4,21 +4,22 @@
 Maintainer: Tobias Frost <tobi@debian.org>
 Uploaders: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Build-Depends: cmake,
-               debhelper (>= 9),
+               debhelper (>= 10),
                libavcodec-dev | libavcodec-ffmpeg-dev,
                libavformat-dev | libavformat-ffmpeg-dev,
                libavutil-dev | libavutil-ffmpeg-dev,
                libglew-dev,
                libjpeg-dev,
                libopenal-dev,
-               libpng12-dev,
+               libpng-dev,
                libsdl2-dev,
                libswscale-dev | libswscale-ffmpeg-dev,
+               rapidjson-dev,
                zlib1g-dev
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Homepage: https://github.com/RobertBeckebans/RBDOOM-3-BFG
-VCS-Browser: http://anonscm.debian.org/cgit/pkg-games/rbdoom3bfg.git
-VCS-Git: git://anonscm.debian.org/pkg-games/rbdoom3bfg.git
+VCS-Browser: https://anonscm.debian.org/cgit/pkg-games/rbdoom3bfg.git
+VCS-Git: https://anonscm.debian.org/git/pkg-games/rbdoom3bfg.git
 
 Package: rbdoom3bfg
 Architecture: any

## rbdoom3bfg 1.1.0~preview3+dfsg+git20161019

=== neo/CMakeLists.txt ===
--- 
+++ 
@@ -26,6 +26,9 @@
 		
 option(WINRT
 		"Build for Windows RT" OFF)
+		
+option(WINDOWS10
+		"Build for Windows 10" OFF)
 		
 option(USE_SYSTEM_ZLIB
                 "Use the system zlib instead of the bundled one" OFF)
@@ -193,12 +196,12 @@
                                        #-DUSE_OPENAL
 					-DUSE_EXCEPTIONS)
         ## Check for Version ##
-        if( WINRT ) # Windows RT
-                add_definitions(-DUSE_WINRT)
+        if( WINRT OR WINDOWS10 ) # Windows RT
+			add_definitions(-DUSE_WINRT)
         endif()
 
         if (USE_INTRINSICS)
-                add_definitions(-DUSE_INTRINSICS)
+			add_definitions(-DUSE_INTRINSICS)
         endif()
 					
 	if(NOT CMAKE_CL_64)
@@ -285,86 +288,56 @@
 file(GLOB FRAMEWORK_ASYNC_SOURCES framework/async/*.cpp)
 
 file(GLOB RENDERER_INCLUDES renderer/*.h)
-	# renderer/AutoRender.h
-	# renderer/AutoRenderBink.h
-	# renderer/BinaryImage.h
-	# renderer/BinaryImageData.h
-	# renderer/BoundsTrack.h
-	# renderer/BufferObject.h
-	# renderer/Cinematic.h
-	# renderer/Font.h
-	# renderer/GLMatrix.h
-	# renderer/GLState.h
-	# renderer/GuiModel.h
-	# renderer/Image.h
-	# renderer/ImageOpts.h
-	# renderer/Interaction.h
-	# renderer/Material.h
-	# renderer/Model.h
-	# renderer/ModelDecal.h
-	# renderer/ModelManager.h
-	# renderer/ModelOverlay.h
-	# renderer/Model_ase.h
-	# #renderer/Model_ColladaHelper.h
-	# #renderer/Model_ColladaParser.h
-	# renderer/Model_local.h
-	# renderer/Model_lwo.h
-	# renderer/Model_ma.h
-	# renderer/Model_md3.h
-	# renderer/RenderLog.h
-	# renderer/RenderProgs.h
-	# renderer/RenderSystem.h
-	# renderer/RenderTexture.h
-	# renderer/RenderWorld.h
-	# renderer/RenderWorld_local.h
-	# renderer/ResolutionScale.h
-	# renderer/ScreenRect.h
-	# renderer/simplex.h
-	# renderer/tr_local.h
-	# renderer/VertexCache.h)
-
-
 file(GLOB RENDERER_SOURCES renderer/*.cpp)
-	# renderer/AutoRender.cpp
-	# renderer/Cinematic.cpp
-	# renderer/Framebuffer.cpp
-	# renderer/GLShader.cpp
-	# renderer/GuiModel.cpp
-	# renderer/Image_files.cpp
-	# renderer/Image_init.cpp
-	# renderer/Image_load.cpp
-	# renderer/Image_process.cpp
-	# renderer/Image_program.cpp
-	# renderer/Interaction.cpp
-	# renderer/Material.cpp
-	# renderer/Model.cpp
-	# renderer/ModelDecal.cpp
-	# renderer/ModelManager.cpp
-	# renderer/ModelOverlay.cpp
-	# renderer/Model_ase.cpp
-	# renderer/Model_beam.cpp
-	# #renderer/Model_ColladaParser.cpp
-	# renderer/Model_liquid.cpp
-	# renderer/Model_lwo.cpp
-	# renderer/Model_ma.cpp
-	# renderer/Model_md3.cpp
-	# renderer/Model_md5.cpp
-	# renderer/Model_prt.cpp
-	# renderer/Model_sprite.cpp
-	# renderer/RenderEntity.cpp
-	# renderer/RenderSystem.cpp
-	# renderer/RenderSystem_init.cpp
-	# renderer/RenderWorld.cpp
-	# renderer/RenderWorld_demo.cpp
-	# renderer/RenderWorld_load.cpp
-	# renderer/RenderWorld_portals.cpp
-	# renderer/VertexCache.cpp
-	# renderer/draw_arb.cpp
-	# renderer/draw_arb2.cpp
-	# renderer/draw_glsl.cpp
-	# renderer/draw_common.cpp
-	# renderer/draw_exp.cpp
-	# renderer/draw_nv10.cpp
-	# renderer/draw_nv20.cpp
-	# renderer/draw_r200.cpp
-	# renderer/tr_backend.cpp
+file(GLOB RENDERER_COLOR_INCLUDES renderer/Color/*.h)
+file(GLOB RENDERER_COLOR_SOURCES renderer/Color/*.cpp)
+file(GLOB RENDERER_DXT_INCLUDES renderer/DXT/*.h)
+file(GLOB RENDERER_DXT_SOURCES renderer/DXT/*.cpp)
+file(GLOB RENDERER_JOBS_INCLUDES renderer/jobs/*.h)
+file(GLOB RENDERER_JOBS_SOURCES renderer/jobs/*.cpp)
+file(GLOB RENDERER_JOBS_DYNAMICSHADOWVOLUME_INCLUDES renderer/jobs/dynamicshadowvolume/*.h)
+file(GLOB RENDERER_JOBS_DYNAMICSHADOWVOLUME_SOURCES renderer/jobs/dynamicshadowvolume/*.cpp)
+file(GLOB RENDERER_JOBS_PRELIGHTSHADOWVOLUME_INCLUDES renderer/jobs/prelightshadowvolume/*.h)
+file(GLOB RENDERER_JOBS_PRELIGHTSHADOWVOLUME_SOURCES renderer/jobs/prelightshadowvolume/*.cpp)
+file(GLOB RENDERER_JOBS_STATICSHADOWVOLUME_INCLUDES renderer/jobs/staticshadowvolume/*.h)
+file(GLOB RENDERER_JOBS_STATICSHADOWVOLUME_SOURCES renderer/jobs/staticshadowvolume/*.cpp)
+file(GLOB RENDERER_OPENGL_INCLUDES renderer/OpenGL/*.h)
+file(GLOB RENDERER_OPENGL_SOURCES renderer/OpenGL/*.cpp)
+file(GLOB RENDERER_SMAA_INCLUDES renderer/SMAA/*.h)
+
+file(GLOB IRRXML_INCLUDES libs/irrxml/src/*.h)
+file(GLOB IRRXML_SOURCES libs/irrxml/src/*.cpp)
+
+if (NOT JPEG_FOUND)
+    set(JPEG_INCLUDES
+        libs/jpeg-6/jchuff.h
+        libs/jpeg-6/jconfig.h
+        libs/jpeg-6/jdct.h
+        libs/jpeg-6/jdhuff.h
+        libs/jpeg-6/jerror.h
+        libs/jpeg-6/jinclude.h
+        libs/jpeg-6/jmemsys.h
+        libs/jpeg-6/jmorecfg.h
+        libs/jpeg-6/jpegint.h
+        libs/jpeg-6/jpeglib.h
+        libs/jpeg-6/jversion.h)
+
+    set(JPEG_SOURCES
+        libs/jpeg-6/jcapimin.cpp
+        libs/jpeg-6/jcapistd.cpp
+        libs/jpeg-6/jccoefct.cpp
+        libs/jpeg-6/jccolor.cpp
+        libs/jpeg-6/jcdctmgr.cpp
+        libs/jpeg-6/jchuff.cpp
+        libs/jpeg-6/jcinit.cpp
+        libs/jpeg-6/jcmainct.cpp
+        libs/jpeg-6/jcmarker.cpp
+        libs/jpeg-6/jcmaster.cpp
+        libs/jpeg-6/jcomapi.cpp
+        libs/jpeg-6/jcparam.cpp
+        libs/jpeg-6/jcphuff.cpp
+        libs/jpeg-6/jcprepct.cpp
+        libs/jpeg-6/jcsample.cpp
+        libs/jpeg-6/jctrans.cpp
+        libs/jpeg-6/jdapimin.cpp
+        libs/jpeg-6/jdapistd.cpp

=== debian/changelog ===
rbdoom3bfg (1.1.0~preview3+dfsg+git20161019-1) unstable; urgency=medium

  * New upstream git snapshot.
  * Drop libavcodec-*-dev from B-D-alternatives; they are no longer availavble.
  * New patch 08-gcc70.patch to fix FTBFS with GCC 7 (Closes: #853638)
  * Update debian/copyright years

 -- Tobias Frost <tobi@debian.org>  Mon, 07 Aug 2017 01:08:39 -0400

=== debian/control ===
--- 
+++ 
@@ -5,15 +5,15 @@
 Uploaders: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Build-Depends: cmake,
                debhelper (>= 10),
-               libavcodec-dev | libavcodec-ffmpeg-dev,
-               libavformat-dev | libavformat-ffmpeg-dev,
-               libavutil-dev | libavutil-ffmpeg-dev,
+               libavcodec-dev,
+               libavformat-dev,
+               libavutil-dev,
                libglew-dev,
                libjpeg-dev,
                libopenal-dev,
                libpng-dev,
                libsdl2-dev,
-               libswscale-dev | libswscale-ffmpeg-dev,
+               libswscale-dev,
                rapidjson-dev,
                zlib1g-dev
 Standards-Version: 3.9.8

=== debian/rules ===
--- 
+++ 
@@ -3,6 +3,8 @@
 # output every command that modifies files on the build system.
 #DH_VERBOSE = 1
 
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
@@ -13,7 +15,7 @@
 endif
 
 %:
-	dh $@ --sourcedirectory=neo --parallel
+	dh $@ --sourcedirectory=neo
 
 # debmake generated override targets
 # This is example for Cmake (See http://bugs.debian.org/641051 )
@@ -22,6 +24,7 @@
 	 -DSDL2=ON -DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
 	 -DUSE_SYSTEM_ZLIB=ON -DUSE_SYSTEM_LIBPNG=ON \
 	 -DUSE_SYSTEM_LIBJPEG=ON -DUSE_SYSTEM_LIBGLEW=ON \
+         -DUSE_SYSTEM_RAPIDJSON=ON \
 	 -DCPU_TYPE=$(DEB_BUILD_ARCH_CPU) \
 	 -DUSE_PRECOMPILED_HEADERS=OFF \
 	 -DCPU_OPTIMIZATION="" \
@@ -40,7 +43,7 @@
 PKD   = $(abspath $(dir $(MAKEFILE_LIST)))
 PKG   = $(word 2,$(shell dpkg-parsechangelog -l$(PKD)/changelog | grep ^Source))
 VER  ?= $(shell dpkg-parsechangelog -l$(PKD)/changelog  -SVersion | sed -e s/^.*git// | cut -d- -f1 )
-DTYPE = +repack1
+DTYPE = +dfsg
 UPSVER ?= $(shell dpkg-parsechangelog -l$(PKD)/changelog -SVersion | cut -d+ -f1)
 
 ## from: https://wiki.debian.org/onlyjob/get-orig-source

=== debian/watch ===
version=3
# note, this watchfile should not be used to download new upstream versions --
# please use get-orig-source; refer to README.source.
# this files only purpose is to track new upstream tagged releases.
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/rbdoom3bfg-$1\.tar\.gz/,\
dversionmangle=s/\+git.*$//;s/\+dfsg.*$//,uversionmangle=s/-/~/,\
repacksuffix=+dfsg \
  https://github.com/RobertBeckebans/RBDOOM-3-BFG/tags .*/v?(\d\S*)\.tar\.gz

## rbdoom3bfg 1.2.0+dfsg~git20180605

=== debian/changelog ===
rbdoom3bfg (1.2.0+dfsg~git20180605-1) unstable; urgency=medium

  * Imported new upstream git snapshot.
  * Change to version 4 watch file to directly track the upstream git repo.
    This also makes the get-orig-source target in d/rules obsolete.
  * Prepare the watchfile for version 1.2 already, as upstream bumped version
    to 1.2 (but not yet officially released)
  * Add patch for the FTBFS with gcc 8.1 (Closes: ##906558)

 -- Tobias Frost <tobi@debian.org>  Mon, 20 Aug 2018 19:44:17 +0200

rbdoom3bfg (1.1.0~preview3+dfsg+git20180204-1) unstable; urgency=medium

  * New upstreamgit snapshot.
  * Move repository to salsa.d.o.
  * Update d/copyright (new holders, years)
  * Update patch 80-gcc7.fix -- partially applied upstream.
  * Refreshed patch 60-spelling-errors.patch.
  * Fix spelling in 10-lowercase-executable.patch.
  * Add dep3 header to 80-gcc70.patch.
  * Fix spelling error in README.Debian.
  * Update 60-spelling-errors.patch with new finding from lintian.
  * Bump compat to level 11
  * Bump S-V to 4.1.4:
    - copyright format URI changed to https.

 -- Tobias Frost <tobi@debian.org>  Fri, 06 Apr 2018 20:20:14 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Tobias Frost <tobi@debian.org>
 Uploaders: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Build-Depends: cmake,
-               debhelper (>= 10),
+               debhelper (>= 11),
                libavcodec-dev,
                libavformat-dev,
                libavutil-dev,
@@ -16,10 +16,10 @@
                libswscale-dev,
                rapidjson-dev,
                zlib1g-dev
-Standards-Version: 3.9.8
+Standards-Version: 4.1.4
 Homepage: https://github.com/RobertBeckebans/RBDOOM-3-BFG
-VCS-Browser: https://anonscm.debian.org/cgit/pkg-games/rbdoom3bfg.git
-VCS-Git: https://anonscm.debian.org/git/pkg-games/rbdoom3bfg.git
+VCS-Browser: https://salsa.debian.org/games-team/rbdoom3bfg
+VCS-Git: https://salsa.debian.org/games-team/rbdoom3bfg.git
 
 Package: rbdoom3bfg
 Architecture: any

## rbdoom3bfg 1.2.0+dfsg~git20181013

=== neo/CMakeLists.txt ===
--- 
+++ 
@@ -19,7 +19,10 @@
 		"Use OpenAL soft instead of XAudio2" OFF)
 
 option(FFMPEG
-		"Use FMPEG to render Bink videos" ON)
+		"Use FMPEG to render Bink videos" OFF)
+
+option(BINKDEC
+		"Use included libbinkdec to render Bink videos" ON)
 
 option(ONATIVE
 		"Optimize for the host CPU" OFF)
@@ -42,11 +45,18 @@
 option(USE_SYSTEM_LIBGLEW
                 "Use the system libglew instead of the bundled one" OFF)
 
+option(USE_SYSTEM_RAPIDJSON
+                "Use the system rapidjson instead of the bundled one" OFF)
+
 set(CPU_TYPE "" CACHE STRING "When set, passes this string as CPU-ID which will be embedded into the binary.")
 
 set(CPU_OPTIMIZATION "-mmmx -msse -msse2" CACHE STRING "Which CPU specific optimitations should be used beside the compiler's default?")
 
 option(USE_INTRINSICS "Compile using intrinsics (e.g mmx, sse, msse2)" ON)
+
+if(FFMPEG AND BINKDEC)
+	message(FATAL_ERROR "Only one of FFMPEG and BINKDEC (or neither) can be enabled at a time")
+endif()
 
 if(UNIX)
 	set(OPENAL TRUE)
@@ -97,25 +107,25 @@
 		add_definitions(-DUSE_EXCEPTIONS)
 	#endif()
 	
-	# the warnings are used for every profile anyway, so put them in a variable
-	set(my_warn_flags "-Wno-pragmas -Wno-unused-variable -Wno-switch -Wno-unused-value -Winvalid-pch -Wno-multichar")
-	
+	add_compile_options(-Wno-pragmas -Wno-unused-variable -Wno-switch -Wno-unused-value -Winvalid-pch -Wno-multichar)
 	if(CMAKE_C_COMPILER_ID STREQUAL "Clang")
-		# append clang-specific settings for warnings (the second one make sure clang doesn't complain
+		# add clang-specific settings for warnings (the second one make sure clang doesn't complain
 		# about unknown -W flags, like -Wno-unused-but-set-variable)
-		set(my_warn_flags "${my_warn_flags} -Wno-local-type-template-args -Wno-unknown-warning-option -Wno-inline-new-delete -Wno-switch-enum")
+		add_compile_options(-Wno-local-type-template-args -Wno-unknown-warning-option -Wno-inline-new-delete -Wno-switch-enum)
 	endif()
 	
 	if(NOT CMAKE_CROSSCOMPILING AND ONATIVE)
 		add_definitions(-march=native)
 	endif()
 
-	set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -D_DEBUG -O0 -ggdb -fno-strict-aliasing ${my_warn_flags}")
-	#set(CMAKE_C_FLAGS_DEBUGALL "${CMAKE_C_FLAGS_DEBUGALL} -g -ggdb -D_DEBUG -fno-strict-aliasing ${my_warn_flags}")
-	#set(CMAKE_C_FLAGS_PROFILE "${CMAKE_C_FLAGS_PROFILE} -g -ggdb -D_DEBUG -O1 -fno-omit-frame-pointer -fno-strict-aliasing ${my_warn_flags}")
-	set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -O3 -ffast-math -fno-unsafe-math-optimizations -fomit-frame-pointer -fno-strict-aliasing ${my_warn_flags}")
-	set(CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_RELWITHDEBINFO} -g -O3 -ffast-math -fno-unsafe-math-optimizations -fomit-frame-pointer -fno-strict-aliasing ${my_warn_flags}")
-	set(CMAKE_C_FLAGS_MINSIZEREL "${CMAKE_C_FLAGS_MINSIZEREL} -Os -ffast-math -fno-unsafe-math-optimizations -fomit-frame-pointer -fno-strict-aliasing ${my_warn_flags}")
+	add_compile_options(-fno-strict-aliasing)
+
+	set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -D_DEBUG -O0 -ggdb")
+	#set(CMAKE_C_FLAGS_DEBUGALL "${CMAKE_C_FLAGS_DEBUGALL} -g -ggdb -D_DEBUG")
+	#set(CMAKE_C_FLAGS_PROFILE "${CMAKE_C_FLAGS_PROFILE} -g -ggdb -D_DEBUG -O1 -fno-omit-frame-pointer")
+	set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -O3 -ffast-math -fno-unsafe-math-optimizations -fomit-frame-pointer")
+	set(CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_RELWITHDEBINFO} -g -O3 -ffast-math -fno-unsafe-math-optimizations -fomit-frame-pointer")
+	set(CMAKE_C_FLAGS_MINSIZEREL "${CMAKE_C_FLAGS_MINSIZEREL} -Os -ffast-math -fno-unsafe-math-optimizations -fomit-frame-pointer")
 	
 	set(CMAKE_CXX_FLAGS_DEBUG ${CMAKE_C_FLAGS_DEBUG})
 	#set(CMAKE_CXX_FLAGS_DEBUGALL ${CMAKE_C_FLAGS_DEBUGALL})
@@ -272,6 +282,17 @@
     set(GLEW_LIBRARY "" )
     add_definitions(-DGLEW_STATIC)
 endif (GLEW_FOUND)
+
+if(USE_SYSTEM_RAPIDJSON)
+find_package(rapidjson REQUIRED)
+endif(USE_SYSTEM_RAPIDJSON)
+
+if (RAPIDJSON_FOUND)
+	include_directories("${RAPIDJSON_INCLUDE_DIRS}")
+	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${RAPIDJSON_CXX_FLAGS}")
+else (RAPIDJSON_FOUND)
+	include_directories("libs/rapidjson/include")
+endif (RAPIDJSON_FOUND)
 
 add_subdirectory(idlib)
 
@@ -331,13 +352,3 @@
         libs/jpeg-6/jchuff.cpp
         libs/jpeg-6/jcinit.cpp
         libs/jpeg-6/jcmainct.cpp
-        libs/jpeg-6/jcmarker.cpp
-        libs/jpeg-6/jcmaster.cpp
-        libs/jpeg-6/jcomapi.cpp
-        libs/jpeg-6/jcparam.cpp
-        libs/jpeg-6/jcphuff.cpp
-        libs/jpeg-6/jcprepct.cpp
-        libs/jpeg-6/jcsample.cpp
-        libs/jpeg-6/jctrans.cpp
-        libs/jpeg-6/jdapimin.cpp
-        libs/jpeg-6/jdapistd.cpp

=== debian/changelog ===
rbdoom3bfg (1.2.0+dfsg~git20181013-1) unstable; urgency=medium

  * New upstream git snaphot.
    - Removing applied patches: 50-system-rapidjson and 90-gcc-fix.
    - Refresh patch 10-lowercase-executable.
  * Bump SV to 4.3.0 -- no changes required

 -- Tobias Frost <tobi@debian.org>  Sun, 30 Dec 2018 01:40:24 +0100

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
                libswscale-dev,
                rapidjson-dev,
                zlib1g-dev
-Standards-Version: 4.1.4
+Standards-Version: 4.3.0
 Homepage: https://github.com/RobertBeckebans/RBDOOM-3-BFG
 VCS-Browser: https://salsa.debian.org/games-team/rbdoom3bfg
 VCS-Git: https://salsa.debian.org/games-team/rbdoom3bfg.git

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none, pretty=1.2.0+dfsg~git%cd, dversionmangle=s/\+dfsg\d*$//" \
https://github.com/RobertBeckebans/RBDOOM-3-BFG.git \
HEAD debian uupdate
